package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import net.sf.json.JSONObject;

public class tool {
  public static void compilejavaToClass(String path) {
    JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
    int result = compiler.run(null, null, null, new String[] { path });
    System.out.print(String.valueOf(path) + "=================================");
    System.out.println((result == 0) ? "编译成功" : "编译失败");
  }
  
  public static void compilejava(String filePath, List<String> jarPath, String targetDir, String sourceDir) {
    try {
      System.out.println(System.getProperty("user.dir"));
      JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
      DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<>();
      StandardJavaFileManager fileManager = compiler.getStandardFileManager(diagnostics, (Locale)null, (Charset)null);
      File sourceFile = new File(filePath);
      List<File> sourceFileList = new ArrayList<>();
      getSourceFiles(sourceFile, sourceFileList);
      Iterable<? extends JavaFileObject> compilationUnits = fileManager.getJavaFileObjectsFromFiles(sourceFileList);
      StringBuilder jar = new StringBuilder();
      for (int j = 0; j < jarPath.size(); j++)
        jar.append(getJarFiles(jarPath.get(j))); 
      Iterable<String> options = Arrays.asList(new String[] { "-encoding", "UTF-8", "-classpath", jar.toString(), "-d", targetDir, "-sourcepath", sourceDir });
      JavaCompiler.CompilationTask task = compiler.getTask((Writer)null, fileManager, diagnostics, options, (Iterable<String>)null, compilationUnits);
      boolean success = task.call().booleanValue();
      fileManager.close();
      System.out.println(success ? "编译成功" : "编译失败");
      System.out.println(diagnostics.getDiagnostics().size());
      for (Diagnostic<? extends JavaFileObject> diagnostic : diagnostics.getDiagnostics()) {
        String str = String.format(
            "Code: %s%nKind: %s%nPosition: %s%nStart Position: %s%nEnd Position: %s%nSource: %s%nMessage:   %s%n", new Object[] { diagnostic.getCode(), diagnostic.getKind(), 
              Long.valueOf(diagnostic.getPosition()), Long.valueOf(diagnostic.getStartPosition()), 
              Long.valueOf(diagnostic.getEndPosition()), diagnostic.getSource(), 
              diagnostic.getMessage(null) });
        System.out.println(str);
      } 
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  public static void getSourceFiles(File sourceFile, List<File> sourceFileList) {
    if (sourceFile.exists() && sourceFileList != null)
      if (sourceFile.isDirectory()) {
        File[] childrenFiles = sourceFile.listFiles();
        byte b;
        int i;
        File[] arrayOfFile1;
        for (i = (arrayOfFile1 = childrenFiles).length, b = 0; b < i; ) {
          File childFile = arrayOfFile1[b];
          getSourceFiles(childFile, sourceFileList);
          b++;
        } 
      } else {
        sourceFileList.add(sourceFile);
      }  
  }
  
  public static String getJarFiles(String jarPath) {
    File sourceFile = new File(jarPath);
    String jars = "";
    if (sourceFile.exists() && 
      sourceFile.isDirectory()) {
      File[] childrenFiles = sourceFile.listFiles();
      if (childrenFiles.length > 0)
        for (int f = 0; f < childrenFiles.length; f++) {
          File ff = childrenFiles[f];
          String name = ff.getName();
          if (name.endsWith(".jar"))
            jars = String.valueOf(jars) + ff.getAbsolutePath() + ";"; 
        }  
    } 
    return jars;
  }
  
  public static String FirstCharLower(String entityName) {
    if (entityName.indexOf("_") > 0)
      entityName = entityName.split("_")[1]; 
    return String.valueOf(entityName.substring(0, 1).toLowerCase()) + entityName.substring(1);
  }
  
  public static String FirstCharUpper(String entityName) {
    if (entityName.indexOf("_") > 0)
      entityName = entityName.split("_")[1]; 
    return String.valueOf(entityName.substring(0, 1).toUpperCase()) + entityName.substring(1);
  }
  
  public static JSONObject getRequestJSONObject(HttpServletRequest request) {
    Enumeration<?> rnames = request.getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = request.getParameter(thisName);
      if (thisName.indexOf("_TJ") > 0) {
        String[] str = thisName.split("_");
        jsonObject.put(str[0], thisValue);
      } 
    } 
    return jsonObject;
  }
  
  public static JSONObject getRequestJSONObjects(HttpServletRequest request) {
    Enumeration<?> rnames = request.getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = request.getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    return jsonObject;
  }
  
  public static Map<String, Object> getRequestParamsMaps(HttpServletRequest request) {
    Enumeration<?> rnames = request.getParameterNames();
    Map<String, Object> map = new HashMap<>();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      if (!"sort".equals(thisName) && !"order".equals(thisName)) {
        String thisValue = request.getParameter(thisName);
        map.put(thisName, thisValue);
      } 
    } 
    return map;
  }
  
  public static Map<String, Object> getParamssetRequest(HttpServletRequest request) {
    Enumeration<?> rnames = request.getParameterNames();
    Map<String, Object> map = new HashMap<>();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      if (!"sort".equals(thisName) && !"order".equals(thisName)) {
        String thisValue = request.getParameter(thisName);
        map.put(thisName, thisValue);
      } 
    } 
    return map;
  }
}
